global INTir 

% IR scattering
% -------------------------------------------------------------------------
nir = round(([z1, z2, z3, z4, z5, z6] - z0) / dz);
F21 = zeros(Nn, length(nir), Nn);
for n2 = 1 : Nn
    for n1 = n2 : Nn
        F21(n2, :, n1) = U0 * eta(n2, nir) .* eta(n1, nir);
        if (n2 ~= n1)
            F21(n1, :, n2) = F21(n2, :, n1);
        end
    end
end
% -------------------------------------------------------------------------

% Memory alocation
% -------------------------------------------------------------------------
W30lo = zeros(1, length(Bmin : dB : Bmax));
W30ir = zeros(1, length(Bmin : dB : Bmax));
W30loir = zeros(1, length(Bmin : dB : Bmax));

N20lo = zeros(1, length(Bmin : dB : Bmax));
N30lo = zeros(1, length(Bmin : dB : Bmax));

N20loir = zeros(1, length(Bmin : dB : Bmax));
N30loir = zeros(1, length(Bmin : dB : Bmax));

g32lo = zeros(1, length(Bmin : dB : Bmax));
g32loir = zeros(1, length(Bmin : dB : Bmax));
% -------------------------------------------------------------------------

indB = 0;
for B = Bmin : dB : Bmax
    indB = indB + 1;
    
    % Update a wait bar dialog box
    waitbar(indB/((Bmax-Bmin)/dB+1),h_wait)
    
    disp(B)
    
    % An magnetic field breaks energy spectrum into discrete Landau levels
    % ---------------------------------------------------------------------
    E1_0 = Ekenberg(En(1), 0, mp1, B);
    E3_0 = Ekenberg(En(3), 0, mp3, B);
    
    lmax1 = 0;
    E1l = zeros(1, lmax1p);
    for l1 = 0 : lmax1p
        if ((Ekenberg(En(1), l1, mp1, B) < Ekenberg(En(1), l1 + 1, mp1, B)) && (Ekenberg(En(1), l1, mp1, B) < E3_0 + dEcut))
            lmax1 = lmax1 + 1;
            E1l(lmax1) = Ekenberg(En(1), l1, mp1, B);
        else
            break
        end
    end
    E1l = E1l(1 : lmax1);
    lmax1 = lmax1 - 1; % index l of E1l is in range 0 : lmax1
    
    lmax2 = 0;
    E2l = zeros(1, lmax2p);
    for l2 = 0 : lmax2p
        if ((Ekenberg(En(2), l2, mp2, B) < Ekenberg(En(2), l2 + 1, mp2, B)) && (Ekenberg(En(2), l2, mp2, B) < E3_0 + dEcut))
            lmax2 = lmax2 + 1;
            E2l(lmax2) = Ekenberg(En(2), l2, mp2, B);
        else
            break
        end
    end
    E2l = E2l(1 : lmax2);
    lmax2 = lmax2 - 1; % index l of E2l is in range 0 : lmax2
    
    lmax3 = 0;
    E3l = zeros(1, lmax3p);
    for l3 = 0 : lmax3p
        if ((Ekenberg(En(3), l3, mp3, B) < Ekenberg(En(3), l3 + 1, mp3, B)) && (Ekenberg(En(3), l3, mp3, B) < E3_0 + dEcut))
            lmax3 = lmax3 + 1;
            E3l(lmax3) = Ekenberg(En(3), l3, mp3, B);
        else
            break
        end
    end
    E3l = E3l(1 : lmax3);
    lmax3 = lmax3 - 1; % index l of E3l is in range 0 : lmax3
    % ---------------------------------------------------------------------
    
    % IR scattering
    % ---------------------------------------------------------------------
    INTir = -ones(max([lmax1 + 1, lmax2 + 1, lmax3 + 1]), max([lmax1 + 1, lmax2 + 1, lmax3 + 1]));
    % ---------------------------------------------------------------------
    
    % Sort energy in ascending order
    % ---------------------------------------------------------------------
    Enl = [E1l, E2l, E3l];
    N = length(Enl);
    n = [ones(1, lmax1 + 1), 2 * ones(1, lmax2 + 1), 3 * ones(1, lmax3 + 1)];
    l = [0 : lmax1, 0 : lmax2, 0 : lmax3];
    if ((N ~= length(n)) || (N ~= length(l)))
        error('Greska! Duzine nizova Enl, n i l nisu jednake!')
    end
    [Enl, n, l] = sortEnl(Enl, n, l);
    % ---------------------------------------------------------------------
            
    % Transition matrix element
    % ---------------------------------------------------------------------
    MWlo = zeros(N, N);
    MWir = zeros(N, N);
    for i = 1 : N
        for j = 1 : (i - 1)
            MWlo(i, j) = WLO(Enl(i), l(i), Enl(j), l(j), Gqp(n(i), :, n(j)), qp, B, TEMP, delta);
            MWlo(j, i) = MWlo(i, j) / exp(hbaromLO * e / kB / TEMP);
            
            MWir(i, j) = WIR(Enl(i), l(i), Enl(j), l(j), F21(n(i), :, n(j)), B, DELTA, LAMBDA, delta);
            MWir(j, i) = MWir(i, j);
        end
    end
    MWloir = MWlo + MWir;
    % ---------------------------------------------------------------------
    
    % Electron relaxation rate for transitions from the ground laser level
    % of the third subband into the two sets of Landau levels of the the
    % lower subbands
    % ---------------------------------------------------------------------
    W30lo(indB) = sum(MWlo((n == 3) & (l == 0), (n == 2) | (n == 1)));
    W30ir(indB) = sum(MWir((n == 3) & (l == 0), (n == 2) | (n == 1)));
    W30loir(indB) = W30lo(indB) + W30ir(indB);
    % ---------------------------------------------------------------------
    
    % Distribution of density
    % ---------------------------------------------------------------------
    jnl = zeros(1, N);
    sum1 = 0;
    sum3 = 0;
    for i = 1 : N
        if (n(i) == 1)
           sum1 = sum1 + exp(-Enl(i) * e / kB / TEMP);
        end
        if (n(i) == 3)
           sum3 = sum3 + exp(-Enl(i) * e / kB / TEMP);
        end       
    end
    for i = 1 : N
        if (n(i) == 1)
           jnl(i) = exp(-Enl(i) * e / kB / TEMP) / sum1 / e;
        end
        if (n(i) == 3)
           jnl(i) = -exp(-Enl(i) * e / kB / TEMP) / sum3 / e;
        end       
    end
    % ---------------------------------------------------------------------
    
    % Rate equations
    % ---------------------------------------------------------------------
    [Jlo Nnllo] = iterrateequ(MWlo, jnl, N, B);
    [Jloir Nnlloir] = iterrateequ(MWloir, jnl, N, B);
    % ---------------------------------------------------------------------
    
    N20lo(indB) = Nnllo((n == 2) & (l == 0));
    N30lo(indB) = Nnllo((n == 3) & (l == 0));
    N20loir(indB) = Nnlloir((n == 2) & (l == 0));
    N30loir(indB) = Nnlloir((n == 3) & (l == 0));
    
    % Optical gain (per unit of injection current)
    g32lo(indB) = gainQCL(Enl, Nnllo, n, l, d32, Jlo);
    g32loir(indB) = gainQCL(Enl, Nnlloir, n, l, d32, Jloir);

end

W30lo = W30lo / 10 ^ 12; % 1 / ps
W30ir = W30ir / 10 ^ 12; % 1 / ps
W30loir = W30loir / 10 ^ 12; % 1 / ps
