% IR preparation
% -------------------------------------------------------------------------
nir = ([z1, z2, z3, z4, z5, z6] - z0) / dz;
F21 = zeros(N, length(nir), N);
for n2 = 1 : N
    for n1 = n2 : N
        F21(n2, :, n1) = U0 * eta(n2, ceil(nir)) .* eta(n1, ceil(nir));
        if (n2 ~= n1)
            F21(n1, :, n2) = F21(n2, :, n1);
        end
    end
end
% -----------------------------------------------------------------------
      
% transition matrix elements
% ---------------------------------------------------------------------
MTAUlo = zeros(N, N);
MTAUir = zeros(N, N);
for i = 1 : N    
    for j = 1 : (i - 1)        
        MTAUlo(i, j) = WLO_opt(En(i), En(j), TEMP, eta(j, :), eta(i, :), z);
        MTAUlo(j, i) = MTAUlo(i, j) / exp(hbaromLO * e / kB / TEMP);            
        MTAUir(i, j) = WIR_opt(En(i), En(j), F21(i, :, j), DELTA, LAMBDA, delta, mw);
        MTAUir(j, i) = MTAUir(i, j);
    end
end

MTAUloir = MTAUlo .* MTAUir ./ (MTAUlo + MTAUir) * 1e12;
TAU3loir = MTAUloir(3, 1) .* MTAUloir(3, 2) ./ (MTAUloir(3, 1) + MTAUloir(3, 2));
% ---------------------------------------------------------------------    