function W = WLO(Enl2, l2, Enl1, l1, Gqp21, qp, B, TEMP, delta)
% LO Phonon Scattering rate between levels (n2, l2) and (n1, l1)

    global hbaromLO NDLcut e hbar Angstrom kB epsP eps0
    
    if (abs(Enl2 - Enl1 - hbaromLO) > NDLcut * delta)
        W = 0;
    else
        beta = sqrt(e * B / hbar) * Angstrom; % 1 / Angstrom
        Nq = 1 / (exp(hbaromLO * e / kB / TEMP) - 1);
        
        % time step size for qp
        dqp = (qp(end) - qp(1)) / (length(qp) -  1);
        
        % Simpson numerical integration for qp
        % -----------------------------------------------------------------
        % simpson1D -> odd number
        if (rem(length(qp), 2) == 0)
            qp = qp(1 : end - 1);
            Gqp21 = Gqp21(1 : end - 1);
            % new time step size for qp
            dqp = (qp(end) - qp(1)) / (length(qp) -  1);
        end
        % simpson 1D
        sim1d = ones(1, length(qp));
        sim1d = 4 * (rem(find(sim1d), 2) == 0) + 2 * (rem(find(sim1d), 2) == 1);
        sim1d(1) = 1;
        sim1d(end) = 1;
        % -----------------------------------------------------------------
        
        I = sum(sim1d .* Gqp21 .* F2(l2, l1, qp, beta));

        I = I * dqp / 3;
    
        W = e ^ 2 * hbaromLO / hbar / 4 / epsP / eps0 * JLO(Enl2, Enl1, delta) * (Nq + 1) * I;
        W = W / Angstrom; % 1 / s
    end

end
