% main1_opt calculates subband positions at zero magnetic field and 
% corresponding wave functions

param1

Ub = min(U) + U0;

% Set minimum and maximum of energy range
E0min = 0; % eV ***
dE0 = 0.00025; % eV ***
E0max = 0.35; % eV ***

% Memory alocation
eta123 = zeros(Nz, 100); % wave functions
E123 = zeros(1, 100); % eigenvalues

first = 1;
Nn = 0;
for E0 = E0min : dE0 : E0max
    pause( 1e-3 )
    [eta0, eta0Nzr] = shooting(E0);
    E0r = E0;    
    if (first)
        first = 0;
    elseif (sign(eta0Nzl) * sign(eta0Nzr) <= 0)
        E = bisect(E0l, E0r);
        [eta, etaNz] = shooting(E);       
        Nn = Nn + 1;           
        eta123(:, Nn) = eta;
        E123(Nn) = E;
    end    
    E0l = E0r;
    eta0Nzl = eta0Nzr;
end

% Clear unused part of alocated memory
eta123 = eta123(1 : Nz, 1 : Nn);
E123 = E123(1 : Nn);