set(0,'DefaultTextFontsize', 11, ...
'DefaultTextFontname', 'Times New Roman', ...
'DefaultAxesFontsize', 12, ...
'DefaultAxesFontname', 'Times New Roman', ...
'DefaultLineLineWidth', 1)

global mw z1 z2 z3 z4 z5 z6 dz z Nz bwbwbwb m

phyconst

% Effective electron mass in AlAs/GaAS
mAlAs = 0.15 * m0;
mGaAs = 0.067 * m0;

% Effective mass in quantum well/barrier
mw = mGaAs;
mb = mAlAs * X + mGaAs * (1 - X);

% Dimensions of structure with 3 wells and 4 barriers
zb0 = 50; % Angstrom
% zw0; % Angstrom
% zb1; % Angstrom
% zw1; % Angstrom
% zb2; % Angstrom
% zw2; % Angstrom
zb3 = 50; % Angstrom

% Length of one cascaded period
L = zb0 + zw0 + zb1 + zw1 + zb2 + zw2 + zb3;

z0 = -L / 2;
z1 = z0 + zb0;
z2 = z1 + zw0;
z3 = z2 + zb1;
z4 = z3 + zw1;
z5 = z4 + zb2;
z6 = z5 + zw2;
z7 = z6 + zb3;

% z coordinate
dz = 0.01;
z = -L / 2 : dz : L / 2; % Angstrom
Nz = length(z);

% 3 wells and 4 barriers
bwbwbwb = ((z0 <= z) & (z <= z1)) + ((z2 <= z) & (z <= z3)) + ...
            ((z4 <= z) & (z <= z5)) + ((z6 <= z) & (z <= z7));

% Effective mass
m = mw * (bwbwbwb == 0) + mb * (bwbwbwb == 1);


